// aflow_chull_python.cpp automatic generated
std::string AFLOW_CHULL_PYTHON_PY="\
#!/usr/bin/env python \n\
 \n\
import json \n\
import subprocess \n\
import os \n\
 \n\
class CHull: \n\
 \n\
    def __init__(self, aflow_executable='aflow'): \n\
        self.aflow_executable = aflow_executable \n\
 \n\
    def aflow_command(self, cmd): \n\
        try: \n\
            return subprocess.check_output( \n\
                self.aflow_executable + cmd, \n\
                shell=True \n\
            ) \n\
        except subprocess.CalledProcessError: \n\
            print('Error aflow executable not found at: ' + self.aflow_executable) \n\
 \n\
    def get_hull(self, alloy, options = None): \n\
        command = ' --chull --force' \n\
        if options: \n\
            command += ' ' + options \n\
 \n\
        output = self.aflow_command( \n\
            command + ' --print=json --screen_only --alloy=' + alloy \n\
        ) \n\
        #print('output: ' + output) \n\
        res_json = json.loads(output) \n\
        return res_json \n\
 \n\
    def get_distance_to_hull(self, alloy, off_hull_point, options = None): \n\
        command = ' --chull --distance_to_hull=' + off_hull_point \n\
        if options: \n\
            command += ' ' + options \n\
         \n\
        output = self.aflow_command( \n\
            command + ' --print=json --screen_only --alloy=' + alloy \n\
        ) \n\
        #print('output: ' + output) \n\
        res_json = json.loads(output) \n\
        return res_json \n\
     \n\
    def get_stability_criterion(self, alloy, hull_point, options = None): \n\
        command = ' --chull --stability_criterion=' + hull_point \n\
        if options: \n\
            command += ' ' + options \n\
         \n\
        output = self.aflow_command( \n\
            command + ' --print=json --screen_only --alloy=' + alloy \n\
        ) \n\
        #print('output: ' + output) \n\
        res_json = json.loads(output) \n\
        return res_json \n\
 \n\
    def get_hull_energy(self, alloy, composition, options = None): \n\
        command = ' --chull --hull_energy=' + ','.join([ str(comp) for comp in composition ]) \n\
        if options: \n\
            command += ' ' + options \n\
         \n\
        output = self.aflow_command( \n\
            command + ' --print=json --screen_only --alloy=' + alloy \n\
        ) \n\
        #print('output: ' + output) \n\
        res_json = json.loads(output) \n\
        return res_json \n\
 \n\
";
